
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

/* 
 * platineType.h:     La SDI_F de platine
 *
 * Utilise par le module et par les clients
 * (inclut dans platineMsgLib.h et platinePosterLib.h)
 * 
 */

#ifndef platine_TYPE_H
#define platine_TYPE_H

#include "genom/modules.h"
#include "platineError.h"

/* Nombre de tache d'execution de ce module */
#define PLATINE_NB_EXEC_TASK                   (2)


#endif
#ifndef platine_TYPE1_H
#define platine_TYPE1_H

#include "/opt/openrobots/include/genBasic/genBasicStruct.h"
#include "/opt/openrobots/include/pom/pomStruct.h"
#include "platineStruct.h"

/*
 * Structure de donnees interne
 */
typedef struct MODULE_PLATINE_SDI {
	PLATINE_STATES states;
	PLATINE_PARAMS_STR platineParams;
	int updatePosterPeriod;
	int platineDecount;
	int initPtParamsFlag;
	PLATINE_DRIVER_PARAMS driverParams;
	int verbose;
	PLATINE_UNITY unity;
	PLATINE_REF_POS_STR refPos;
	PLATINE_SET_PARAM setParam;
	PLATINE_AXIS_SET_SPEED_PROFILE setSpeedProfile;
	PLATINE_PARAMS_STR platineParamsRq;
	PLATINE_CONVERT_PARAMS constConvert;
	PLATINE_SET_SETTING settings;
	PLATINE_CARTESIAN_TARGET cartesianTarget;
	PLATINE_TRACK_TARGET trackTarget;
	GEN_STRING64 posterName;
	long int trackPosterId;
	PLATINE_STEP_AXIS_PARAMS stepAxisParams[2];
	GEN_STRING64 asciiCmd;
	POM_SE_POSTER exportPomSE;
	PLATINE_POS_RQST platineOriginPosOnRobotRqst;
	POM_SENSOR_POS platineOriginPosOnRobot;
} PLATINE_STR;


#endif

