
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] platineInstall] >= 0 } {
    interp expose {} platineInstall
}

proc ::platineInstall { name } {
    foreach rqst { "InitDriver" "GetSerialParams" "Reset" "GetPlatineParams" "SetSpeed" "SetSpeedProfile" "SetPowerModes" "SetUpdatePosterPeriod" "Stop" "SetOffset" "CmdPosPan" "CmdPosTilt" "CmdPosCoord" "TrackPos" "TrackSpeed" "SetPlatinePosOnRobot" "GetPlatinePosOnRobot" "AimAtTargetPoint" "TrackTargetPoint" "GetConstConvert" "SetDefaultPtSettings" "SendAsciiCmd" "ResetPTUdriver" "GetUpdatePosterPeriod" "GetOffset" "VerboseSwitch" "StatestateRadPosterRead" "StatestateDegPosterRead" "SEPosexportPomSEPosterRead" "ParamsplatineParamsPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} platine$rqst $name
    }
}

interp hide {} platineInstall




# InitDriver ----------------------------------------------------------

if { [lsearch [interp hidden] platineInitDriver] >= 0 } {
    interp expose {} platineInitDriver
}
if { [lsearch [interp hidden] platineInitDriverFormatOutput] >= 0 } {
    interp expose {} platineInitDriverFormatOutput
}

proc ::platineInitDriver { name args } {
    set format {}
    lappend format [list string "driverParams.deviceName" "" ]
    lappend format [list int "driverParams.baudRate" 0 ]
    lappend format [list int "driverParams.panTrigoRotation" 0 ]

    return [ ::cs::rqstSend "${name}" "InitDriver" \
	"** undocumented **" \
	"PLATINE_DRIVER_PARAMS\n| char deviceName\[32\]\n| int baudRate\n| int panTrigoRotation\n" \
	3 \
	$format \
	$args ]
}


proc ::platineInitDriverFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineInitDriver
interp hide {} platineInitDriverFormatOutput





# GetSerialParams ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetSerialParams] >= 0 } {
    interp expose {} platineGetSerialParams
}
if { [lsearch [interp hidden] platineGetSerialParamsFormatOutput] >= 0 } {
    interp expose {} platineGetSerialParamsFormatOutput
}

proc ::platineGetSerialParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSerialParams" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineGetSerialParamsFormatOutput { list } {
    set format { {} status { } { driverParams { } deviceName { } baudRate { } panTrigoRotation } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetSerialParams
interp hide {} platineGetSerialParamsFormatOutput





# Reset ----------------------------------------------------------

if { [lsearch [interp hidden] platineReset] >= 0 } {
    interp expose {} platineReset
}
if { [lsearch [interp hidden] platineResetFormatOutput] >= 0 } {
    interp expose {} platineResetFormatOutput
}

proc ::platineReset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Reset" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineResetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineReset
interp hide {} platineResetFormatOutput





# GetPlatineParams ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetPlatineParams] >= 0 } {
    interp expose {} platineGetPlatineParams
}
if { [lsearch [interp hidden] platineGetPlatineParamsFormatOutput] >= 0 } {
    interp expose {} platineGetPlatineParamsFormatOutput
}

proc ::platineGetPlatineParams { name args } {
    set format {}
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "unity" "" ]

    return [ ::cs::rqstSend "${name}" "GetPlatineParams" \
	"** undocumented **" \
	"PLATINE_UNITY unity\n" \
	1 \
	$format \
	$args ]
}


proc ::platineGetPlatineParamsFormatOutput { list } {
    set format { {} status { } { platineParamsRq { } { consts { } { pan { } posMin { } posMax { } speedMinMin { } speedMaxMax } { } { tilt { } posMin { } posMax { } speedMinMin { } speedMaxMax } } { } { offsets { } pan { } tilt } { } { speedProfile { } { pan { } minSpeed { } maxSpeed { } baseSpeed { } speed { } accel } { } { tilt { } minSpeed { } maxSpeed { } baseSpeed { } speed { } accel } } { } { power { } { pan { } holdPowerMode { } movePowerMode } { } { tilt { } holdPowerMode { } movePowerMode } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetPlatineParams
interp hide {} platineGetPlatineParamsFormatOutput





# SetSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetSpeed] >= 0 } {
    interp expose {} platineSetSpeed
}
if { [lsearch [interp hidden] platineSetSpeedFormatOutput] >= 0 } {
    interp expose {} platineSetSpeedFormatOutput
}

proc ::platineSetSpeed { name args } {
    set format {}
    lappend format [list double "setParam.val" 0.0 ]
    lappend format [list { "PLATINE_TILT" "PLATINE_PAN" } "setParam.axis" "" ]
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "setParam.unity" "" ]

    return [ ::cs::rqstSend "${name}" "SetSpeed" \
	"** undocumented **" \
	"PLATINE_SET_PARAM\n| double val\n| PLATINE_AXIS axis\n| PLATINE_UNITY unity\n" \
	3 \
	$format \
	$args ]
}


proc ::platineSetSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetSpeed
interp hide {} platineSetSpeedFormatOutput





# SetSpeedProfile ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetSpeedProfile] >= 0 } {
    interp expose {} platineSetSpeedProfile
}
if { [lsearch [interp hidden] platineSetSpeedProfileFormatOutput] >= 0 } {
    interp expose {} platineSetSpeedProfileFormatOutput
}

proc ::platineSetSpeedProfile { name args } {
    set format {}
    lappend format [list { "PLATINE_TILT" "PLATINE_PAN" } "setSpeedProfile.axis" "" ]
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "setSpeedProfile.unity" "" ]
    lappend format [list double "setSpeedProfile.minSpeed" 0.0 ]
    lappend format [list double "setSpeedProfile.maxSpeed" 0.0 ]
    lappend format [list double "setSpeedProfile.baseSpeed" 0.0 ]
    lappend format [list double "setSpeedProfile.speed" 0.0 ]
    lappend format [list double "setSpeedProfile.accel" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetSpeedProfile" \
	"** undocumented **" \
	"PLATINE_AXIS_SET_SPEED_PROFILE\n| PLATINE_AXIS axis\n| PLATINE_UNITY unity\n| double minSpeed\n| double maxSpeed\n| double baseSpeed\n| double speed\n| double accel\n" \
	7 \
	$format \
	$args ]
}


proc ::platineSetSpeedProfileFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetSpeedProfile
interp hide {} platineSetSpeedProfileFormatOutput





# SetPowerModes ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetPowerModes] >= 0 } {
    interp expose {} platineSetPowerModes
}
if { [lsearch [interp hidden] platineSetPowerModesFormatOutput] >= 0 } {
    interp expose {} platineSetPowerModesFormatOutput
}

proc ::platineSetPowerModes { name args } {
    set format {}
    lappend format [list { "PLATINE_HOLD_POWER_OFF" "PLATINE_HOLD_POWER_LOW" "PLATINE_HOLD_POWER_REGULAR" } "power.pan.holdPowerMode" "" ]
    lappend format [list { "PLATINE_MOVE_POWER_HIGH" "PLATINE_MOVE_POWER_LOW" "PLATINE_MOVE_POWER_REGULAR" } "power.pan.movePowerMode" "" ]
    lappend format [list { "PLATINE_HOLD_POWER_OFF" "PLATINE_HOLD_POWER_LOW" "PLATINE_HOLD_POWER_REGULAR" } "power.tilt.holdPowerMode" "" ]
    lappend format [list { "PLATINE_MOVE_POWER_HIGH" "PLATINE_MOVE_POWER_LOW" "PLATINE_MOVE_POWER_REGULAR" } "power.tilt.movePowerMode" "" ]

    return [ ::cs::rqstSend "${name}" "SetPowerModes" \
	"** undocumented **" \
	"PLATINE_POWER_PARAMS\n| PLATINE_AXIS_POWER_PARAMS\n| | PLATINE_HOLD_POWER_MODE holdPowerMode\n| | PLATINE_MOVE_POWER_MODE movePowerMode\n| PLATINE_AXIS_POWER_PARAMS\n| | PLATINE_HOLD_POWER_MODE holdPowerMode\n| | PLATINE_MOVE_POWER_MODE movePowerMode\n" \
	4 \
	$format \
	$args ]
}


proc ::platineSetPowerModesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetPowerModes
interp hide {} platineSetPowerModesFormatOutput





# SetUpdatePosterPeriod ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetUpdatePosterPeriod] >= 0 } {
    interp expose {} platineSetUpdatePosterPeriod
}
if { [lsearch [interp hidden] platineSetUpdatePosterPeriodFormatOutput] >= 0 } {
    interp expose {} platineSetUpdatePosterPeriodFormatOutput
}

proc ::platineSetUpdatePosterPeriod { name args } {
    set format {}
    lappend format [list int "updatePosterPeriod" 0 ]

    return [ ::cs::rqstSend "${name}" "SetUpdatePosterPeriod" \
	"** undocumented **" \
	"int updatePosterPeriod\n" \
	1 \
	$format \
	$args ]
}


proc ::platineSetUpdatePosterPeriodFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetUpdatePosterPeriod
interp hide {} platineSetUpdatePosterPeriodFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] platineStop] >= 0 } {
    interp expose {} platineStop
}
if { [lsearch [interp hidden] platineStopFormatOutput] >= 0 } {
    interp expose {} platineStopFormatOutput
}

proc ::platineStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineStop
interp hide {} platineStopFormatOutput





# SetOffset ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetOffset] >= 0 } {
    interp expose {} platineSetOffset
}
if { [lsearch [interp hidden] platineSetOffsetFormatOutput] >= 0 } {
    interp expose {} platineSetOffsetFormatOutput
}

proc ::platineSetOffset { name args } {
    set format {}
    lappend format [list double "setParam.val" 0.0 ]
    lappend format [list { "PLATINE_TILT" "PLATINE_PAN" } "setParam.axis" "" ]
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "setParam.unity" "" ]

    return [ ::cs::rqstSend "${name}" "SetOffset" \
	"** undocumented **" \
	"PLATINE_SET_PARAM\n| double val\n| PLATINE_AXIS axis\n| PLATINE_UNITY unity\n" \
	3 \
	$format \
	$args ]
}


proc ::platineSetOffsetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetOffset
interp hide {} platineSetOffsetFormatOutput





# CmdPosPan ----------------------------------------------------------

if { [lsearch [interp hidden] platineCmdPosPan] >= 0 } {
    interp expose {} platineCmdPosPan
}
if { [lsearch [interp hidden] platineCmdPosPanFormatOutput] >= 0 } {
    interp expose {} platineCmdPosPanFormatOutput
}

proc ::platineCmdPosPan { name args } {
    set format {}
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "pan.unity" "" ]
    lappend format [list { "PLATINE_ABSOLUTE" "PLATINE_RELATIVE" } "pan.cmdType" "" ]
    lappend format [list double "pan.pos" 0.0 ]
    lappend format [list { "PLATINE_TRUE" "PLATINE_FALSE" } "pan.survEndFlag" "" ]
    lappend format [list int "pan.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "CmdPosPan" \
	"** undocumented **" \
	"PLATINE_REF_AXIS_POS_STR\n| PLATINE_UNITY unity\n| PLATINE_CMD_TYPE cmdType\n| double pos\n| PLATINE_BOOL survEndFlag\n| int unused\n" \
	5 \
	$format \
	$args ]
}


proc ::platineCmdPosPanFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineCmdPosPan
interp hide {} platineCmdPosPanFormatOutput





# CmdPosTilt ----------------------------------------------------------

if { [lsearch [interp hidden] platineCmdPosTilt] >= 0 } {
    interp expose {} platineCmdPosTilt
}
if { [lsearch [interp hidden] platineCmdPosTiltFormatOutput] >= 0 } {
    interp expose {} platineCmdPosTiltFormatOutput
}

proc ::platineCmdPosTilt { name args } {
    set format {}
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "tilt.unity" "" ]
    lappend format [list { "PLATINE_ABSOLUTE" "PLATINE_RELATIVE" } "tilt.cmdType" "" ]
    lappend format [list double "tilt.pos" 0.0 ]
    lappend format [list { "PLATINE_TRUE" "PLATINE_FALSE" } "tilt.survEndFlag" "" ]
    lappend format [list int "tilt.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "CmdPosTilt" \
	"** undocumented **" \
	"PLATINE_REF_AXIS_POS_STR\n| PLATINE_UNITY unity\n| PLATINE_CMD_TYPE cmdType\n| double pos\n| PLATINE_BOOL survEndFlag\n| int unused\n" \
	5 \
	$format \
	$args ]
}


proc ::platineCmdPosTiltFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineCmdPosTilt
interp hide {} platineCmdPosTiltFormatOutput





# CmdPosCoord ----------------------------------------------------------

if { [lsearch [interp hidden] platineCmdPosCoord] >= 0 } {
    interp expose {} platineCmdPosCoord
}
if { [lsearch [interp hidden] platineCmdPosCoordFormatOutput] >= 0 } {
    interp expose {} platineCmdPosCoordFormatOutput
}

proc ::platineCmdPosCoord { name args } {
    set format {}
    lappend format [list { "PLATINE_DEG" "PLATINE_RAD" } "coord.unity" "" ]
    lappend format [list { "PLATINE_ABSOLUTE" "PLATINE_RELATIVE" } "coord.cmdType" "" ]
    lappend format [list double "coord.pan" 0.0 ]
    lappend format [list double "coord.tilt" 0.0 ]
    lappend format [list { "PLATINE_TRUE" "PLATINE_FALSE" } "coord.survEndFlag" "" ]
    lappend format [list int "coord.unused" 0 ]

    return [ ::cs::rqstSend "${name}" "CmdPosCoord" \
	"** undocumented **" \
	"PLATINE_REF_COORD_POS_STR\n| PLATINE_UNITY unity\n| PLATINE_CMD_TYPE cmdType\n| double pan\n| double tilt\n| PLATINE_BOOL survEndFlag\n| int unused\n" \
	6 \
	$format \
	$args ]
}


proc ::platineCmdPosCoordFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineCmdPosCoord
interp hide {} platineCmdPosCoordFormatOutput





# TrackPos ----------------------------------------------------------

if { [lsearch [interp hidden] platineTrackPos] >= 0 } {
    interp expose {} platineTrackPos
}
if { [lsearch [interp hidden] platineTrackPosFormatOutput] >= 0 } {
    interp expose {} platineTrackPosFormatOutput
}

proc ::platineTrackPos { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackPos" \
	"** undocumented **" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::platineTrackPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineTrackPos
interp hide {} platineTrackPosFormatOutput





# TrackSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] platineTrackSpeed] >= 0 } {
    interp expose {} platineTrackSpeed
}
if { [lsearch [interp hidden] platineTrackSpeedFormatOutput] >= 0 } {
    interp expose {} platineTrackSpeedFormatOutput
}

proc ::platineTrackSpeed { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackSpeed" \
	"** undocumented **" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::platineTrackSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineTrackSpeed
interp hide {} platineTrackSpeedFormatOutput





# SetPlatinePosOnRobot ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetPlatinePosOnRobot] >= 0 } {
    interp expose {} platineSetPlatinePosOnRobot
}
if { [lsearch [interp hidden] platineSetPlatinePosOnRobotFormatOutput] >= 0 } {
    interp expose {} platineSetPlatinePosOnRobotFormatOutput
}

proc ::platineSetPlatinePosOnRobot { name args } {
    set format {}
    lappend format [list { "PLATINE_TRUE" "PLATINE_FALSE" } "TRUE: position read by poster which name is given bellow, FALSE: position values given within this request" "PLATINE_TRUE" ]
    lappend format [list int "unused" 0 ]
    lappend format [list double "yaw PTU/robot" 0.000000 ]
    lappend format [list double "pitch PTU/robot" 0.000000 ]
    lappend format [list double "roll PTU/robot" 0.000000 ]
    lappend format [list double "X PTU/robot" -0.232000 ]
    lappend format [list double "Y PTU/robot" 0.000000 ]
    lappend format [list double "Z PTU/robot" 1.711000 ]
    lappend format [list string "Name of the poster with the pos of the platine on the robot" "pomPlatineBaseFramePos" ]

    return [ ::cs::rqstSend "${name}" "SetPlatinePosOnRobot" \
	"Set the position of the origin of the platine on the robot (by default uses POM poster if any)" \
	"PLATINE_POS_RQST\n| PLATINE_BOOL readOriginFrameByPoster\n| int unused\n| POM_EULER\n| | double yaw\n| | double pitch\n| | double roll\n| | double x\n| | double y\n| | double z\n| char platineOriginFramePoster\[32\]\n" \
	9 \
	$format \
	$args ]
}


proc ::platineSetPlatinePosOnRobotFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetPlatinePosOnRobot
interp hide {} platineSetPlatinePosOnRobotFormatOutput





# GetPlatinePosOnRobot ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetPlatinePosOnRobot] >= 0 } {
    interp expose {} platineGetPlatinePosOnRobot
}
if { [lsearch [interp hidden] platineGetPlatinePosOnRobotFormatOutput] >= 0 } {
    interp expose {} platineGetPlatinePosOnRobotFormatOutput
}

proc ::platineGetPlatinePosOnRobot { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetPlatinePosOnRobot" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineGetPlatinePosOnRobotFormatOutput { list } {
    set format { {} status { } { platineOriginPosOnRobotRqst { } readOriginFrameByPoster { } unused { } { platineOriginPosOnRobot { } yaw { } pitch { } roll { } x { } y { } z } { } platineOriginFramePoster } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetPlatinePosOnRobot
interp hide {} platineGetPlatinePosOnRobotFormatOutput





# AimAtTargetPoint ----------------------------------------------------------

if { [lsearch [interp hidden] platineAimAtTargetPoint] >= 0 } {
    interp expose {} platineAimAtTargetPoint
}
if { [lsearch [interp hidden] platineAimAtTargetPointFormatOutput] >= 0 } {
    interp expose {} platineAimAtTargetPointFormatOutput
}

proc ::platineAimAtTargetPoint { name args } {
    set format {}
    lappend format [list double "yaw sensor/PTU" 0.000000 ]
    lappend format [list double "pitch sensor/PTU" 0.000000 ]
    lappend format [list double "roll sensor/PTU" 0.000000 ]
    lappend format [list double "X sensor/PTU" 0.000000 ]
    lappend format [list double "Y sensor/PTU" 0.000000 ]
    lappend format [list double "Z sensor/PTU" 0.053000 ]
    lappend format [list { "POM_FRAME_ORIGIN" "POM_FRAME_BASE" "POM_FRAME_ROBOT" "POM_FRAME_SENSOR" } "Frame for the target" "POM_FRAME_ORIGIN" ]
    lappend format [list int "Stay on target" 1 ]
    lappend format [list double "X target" 0.000000 ]
    lappend format [list double "Y target" 0.000000 ]
    lappend format [list double "Z target" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "AimAtTargetPoint" \
	"Orientes the PTU (or a sensor on the PTU) towards a 3D cartesian point given in parameter. Needs first to know the position of the PTU on the robot. See request SetPlatinePosOnRobot" \
	"PLATINE_CARTESIAN_TARGET\n| POM_EULER\n| | double yaw\n| | double pitch\n| | double roll\n| | double x\n| | double y\n| | double z\n| POM_FRAME frame\n| int stayActivelyOnTarget\n| PLATINE_3D_POINT\n| | double x\n| | double y\n| | double z\n" \
	11 \
	$format \
	$args ]
}


proc ::platineAimAtTargetPointFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineAimAtTargetPoint
interp hide {} platineAimAtTargetPointFormatOutput





# TrackTargetPoint ----------------------------------------------------------

if { [lsearch [interp hidden] platineTrackTargetPoint] >= 0 } {
    interp expose {} platineTrackTargetPoint
}
if { [lsearch [interp hidden] platineTrackTargetPointFormatOutput] >= 0 } {
    interp expose {} platineTrackTargetPointFormatOutput
}

proc ::platineTrackTargetPoint { name args } {
    set format {}
    lappend format [list string "trackTarget.platineTargetPosPoster" "" ]

    return [ ::cs::rqstSend "${name}" "TrackTargetPoint" \
	"Oriente the PTU towards a 3D cartesian point provided by poster. Needs first to know the position of the PTU on the robot. See request SetPlatinePosOnRobot" \
	"PLATINE_TRACK_TARGET\n| char platineTargetPosPoster\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::platineTrackTargetPointFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineTrackTargetPoint
interp hide {} platineTrackTargetPointFormatOutput





# GetConstConvert ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetConstConvert] >= 0 } {
    interp expose {} platineGetConstConvert
}
if { [lsearch [interp hidden] platineGetConstConvertFormatOutput] >= 0 } {
    interp expose {} platineGetConstConvertFormatOutput
}

proc ::platineGetConstConvert { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetConstConvert" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineGetConstConvertFormatOutput { list } {
    set format { {} status { } { constConvert { } ptResolution { } step2rad { } rad2step { } step2deg { } deg2step } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetConstConvert
interp hide {} platineGetConstConvertFormatOutput





# SetDefaultPtSettings ----------------------------------------------------------

if { [lsearch [interp hidden] platineSetDefaultPtSettings] >= 0 } {
    interp expose {} platineSetDefaultPtSettings
}
if { [lsearch [interp hidden] platineSetDefaultPtSettingsFormatOutput] >= 0 } {
    interp expose {} platineSetDefaultPtSettingsFormatOutput
}

proc ::platineSetDefaultPtSettings { name args } {
    set format {}
    lappend format [list { "PLATINE_RESTORE_FACTORY_SETTING" "PLATINE_RESTORE_SAVED_SETTING" "PLATINE_SAVE_SETTING" } "settings" "" ]

    return [ ::cs::rqstSend "${name}" "SetDefaultPtSettings" \
	"** undocumented **" \
	"PLATINE_SET_SETTING settings\n" \
	1 \
	$format \
	$args ]
}


proc ::platineSetDefaultPtSettingsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSetDefaultPtSettings
interp hide {} platineSetDefaultPtSettingsFormatOutput





# SendAsciiCmd ----------------------------------------------------------

if { [lsearch [interp hidden] platineSendAsciiCmd] >= 0 } {
    interp expose {} platineSendAsciiCmd
}
if { [lsearch [interp hidden] platineSendAsciiCmdFormatOutput] >= 0 } {
    interp expose {} platineSendAsciiCmdFormatOutput
}

proc ::platineSendAsciiCmd { name args } {
    set format {}
    lappend format [list string "asciiCmd.name" "" ]

    return [ ::cs::rqstSend "${name}" "SendAsciiCmd" \
	"** undocumented **" \
	"GEN_STRING64\n| char name\[64\]\n" \
	1 \
	$format \
	$args ]
}


proc ::platineSendAsciiCmdFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSendAsciiCmd
interp hide {} platineSendAsciiCmdFormatOutput





# ResetPTUdriver ----------------------------------------------------------

if { [lsearch [interp hidden] platineResetPTUdriver] >= 0 } {
    interp expose {} platineResetPTUdriver
}
if { [lsearch [interp hidden] platineResetPTUdriverFormatOutput] >= 0 } {
    interp expose {} platineResetPTUdriverFormatOutput
}

proc ::platineResetPTUdriver { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "ResetPTUdriver" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineResetPTUdriverFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineResetPTUdriver
interp hide {} platineResetPTUdriverFormatOutput





# GetUpdatePosterPeriod ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetUpdatePosterPeriod] >= 0 } {
    interp expose {} platineGetUpdatePosterPeriod
}
if { [lsearch [interp hidden] platineGetUpdatePosterPeriodFormatOutput] >= 0 } {
    interp expose {} platineGetUpdatePosterPeriodFormatOutput
}

proc ::platineGetUpdatePosterPeriod { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetUpdatePosterPeriod" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineGetUpdatePosterPeriodFormatOutput { list } {
    set format { {} status { } updatePosterPeriod }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetUpdatePosterPeriod
interp hide {} platineGetUpdatePosterPeriodFormatOutput





# GetOffset ----------------------------------------------------------

if { [lsearch [interp hidden] platineGetOffset] >= 0 } {
    interp expose {} platineGetOffset
}
if { [lsearch [interp hidden] platineGetOffsetFormatOutput] >= 0 } {
    interp expose {} platineGetOffsetFormatOutput
}

proc ::platineGetOffset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetOffset" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineGetOffsetFormatOutput { list } {
    set format { {} status { } { setParam { } val { } axis { } unity } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineGetOffset
interp hide {} platineGetOffsetFormatOutput





# VerboseSwitch ----------------------------------------------------------

if { [lsearch [interp hidden] platineVerboseSwitch] >= 0 } {
    interp expose {} platineVerboseSwitch
}
if { [lsearch [interp hidden] platineVerboseSwitchFormatOutput] >= 0 } {
    interp expose {} platineVerboseSwitchFormatOutput
}

proc ::platineVerboseSwitch { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "VerboseSwitch" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::platineVerboseSwitchFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineVerboseSwitch
interp hide {} platineVerboseSwitchFormatOutput





# StatestateRad ----------------------------------------------------------

if { [lsearch [interp hidden] platineStatestateRadPosterRead] >= 0 } {
    interp expose {} platineStatestateRadPosterRead
}
if { [lsearch [interp hidden] platineStatestateRadPosterFormatOutput] >= 0 } {
    interp expose {} platineStatestateRadPosterFormatOutput
}

proc ::platineStatestateRadPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "StatestateRad" \
	"PLATINE_STATE\n| PLATINE_AXIS_STR\n| | double pan\n| | double tilt\n| PLATINE_AXIS_STR\n| | double pan\n| | double tilt\n" \
	$args ]
}


proc ::platineStatestateRadPosterFormatOutput { list } {
    set format { {} status { } { stateRad { } { pos { } pan { } tilt } { } { ref { } pan { } tilt } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineStatestateRadPosterRead
interp hide {} platineStatestateRadPosterFormatOutput





# StatestateDeg ----------------------------------------------------------

if { [lsearch [interp hidden] platineStatestateDegPosterRead] >= 0 } {
    interp expose {} platineStatestateDegPosterRead
}
if { [lsearch [interp hidden] platineStatestateDegPosterFormatOutput] >= 0 } {
    interp expose {} platineStatestateDegPosterFormatOutput
}

proc ::platineStatestateDegPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "StatestateDeg" \
	"PLATINE_STATE\n| PLATINE_AXIS_STR\n| | double pan\n| | double tilt\n| PLATINE_AXIS_STR\n| | double pan\n| | double tilt\n" \
	$args ]
}


proc ::platineStatestateDegPosterFormatOutput { list } {
    set format { {} status { } { stateDeg { } { pos { } pan { } tilt } { } { ref { } pan { } tilt } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineStatestateDegPosterRead
interp hide {} platineStatestateDegPosterFormatOutput





# SEPosexportPomSE ----------------------------------------------------------

if { [lsearch [interp hidden] platineSEPosexportPomSEPosterRead] >= 0 } {
    interp expose {} platineSEPosexportPomSEPosterRead
}
if { [lsearch [interp hidden] platineSEPosexportPomSEPosterFormatOutput] >= 0 } {
    interp expose {} platineSEPosexportPomSEPosterFormatOutput
}

proc ::platineSEPosexportPomSEPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SEPosexportPomSE" \
	"POM_SE_POSTER\n| char seName\[512\]\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::platineSEPosexportPomSEPosterFormatOutput { list } {
    set format { {} status { } { exportPomSE { } seName { } { seConfig { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineSEPosexportPomSEPosterRead
interp hide {} platineSEPosexportPomSEPosterFormatOutput





# ParamsplatineParams ----------------------------------------------------------

if { [lsearch [interp hidden] platineParamsplatineParamsPosterRead] >= 0 } {
    interp expose {} platineParamsplatineParamsPosterRead
}
if { [lsearch [interp hidden] platineParamsplatineParamsPosterFormatOutput] >= 0 } {
    interp expose {} platineParamsplatineParamsPosterFormatOutput
}

proc ::platineParamsplatineParamsPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "ParamsplatineParams" \
	"PLATINE_PARAMS_STR\n| PLATINE_CONST_PARAMS\n| | PLATINE_AXIS_CONST_PARAMS\n| | | double posMin\n| | | double posMax\n| | | double speedMinMin\n| | | double speedMaxMax\n| | PLATINE_AXIS_CONST_PARAMS\n| | | double posMin\n| | | double posMax\n| | | double speedMinMin\n| | | double speedMaxMax\n| PLATINE_OFFSETS_STR\n| | double pan\n| | double tilt\n| PLATINE_SPEED_PROFILE\n| | PLATINE_AXIS_SPEED_PROFILE\n| | | double minSpeed\n| | | double maxSpeed\n| | | double baseSpeed\n| | | double speed\n| | | double accel\n| | PLATINE_AXIS_SPEED_PROFILE\n| | | double minSpeed\n| | | double maxSpeed\n| | | double baseSpeed\n| | | double speed\n| | | double accel\n| PLATINE_POWER_PARAMS\n| | PLATINE_AXIS_POWER_PARAMS\n| | | PLATINE_HOLD_POWER_MODE holdPowerMode\n| | | PLATINE_MOVE_POWER_MODE movePowerMode\n| | PLATINE_AXIS_POWER_PARAMS\n| | | PLATINE_HOLD_POWER_MODE holdPowerMode\n| | | PLATINE_MOVE_POWER_MODE movePowerMode\n" \
	$args ]
}


proc ::platineParamsplatineParamsPosterFormatOutput { list } {
    set format { {} status { } { platineParams { } { consts { } { pan { } posMin { } posMax { } speedMinMin { } speedMaxMax } { } { tilt { } posMin { } posMax { } speedMinMin { } speedMaxMax } } { } { offsets { } pan { } tilt } { } { speedProfile { } { pan { } minSpeed { } maxSpeed { } baseSpeed { } speed { } accel } { } { tilt { } minSpeed { } maxSpeed { } baseSpeed { } speed { } accel } } { } { power { } { pan { } holdPowerMode { } movePowerMode } { } { tilt { } holdPowerMode { } movePowerMode } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} platineParamsplatineParamsPosterRead
interp hide {} platineParamsplatineParamsPosterFormatOutput


